﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AVLExample
{
    class AVLTree
    {
        private  AVLNode root;   //line 10
        public AVLTree ()        //line 11
        {
            root = null;
        }                        //line 14
        //**************
        public AVLNode Root      //line 16
        {
            get
            {
                return root;
            }
            set
            {
                root = value;
            }
        }                      //line 26
        //*****************    //line 27
        public  AVLNode  AVLInsert (AVLNode parent, int item,  ref bool ub) 
        {
            if (parent == null)  //insert element into null tree //line 30
            {
                ub = true;
                parent = new AVLNode(item);
            }
            else if (item < parent.Key)     //line 35
            {
                 parent.Left = AVLInsert(parent.Left, item, ref ub);
                if (ub)                      //line 38
                {
                    //left branch has grown higher
                    switch (parent.Bf)      //line 41
                    {
                        case -1:
                            parent.Bf = 0;
                            ub = false;
                            break;
                        case 0:
                            parent.Bf = 1;
                            break;
                        case 1:
                            parent = RightRotation(parent, ref ub); //line 51
                            break;
                    }           //line 53
                }
            }//end else if          line  55
            else if (item > parent.Key)   //line 56
            {
                parent .Right = AVLInsert(parent.Right, item, ref ub);
                if (ub)   //right branch has grown higer //line 59
                    switch (parent.Bf)   //line 60
                    {
                        case -1:
                            parent.Bf = 0;
                            ub = false; 
                            break;
                        case 0:
                            parent.Bf = -1;
                            break;
                        case 1:
                            parent = LeftRotation(parent, ref ub);  //line 70
                            break;
                    }//end switch             //line 72
            }//end of else if                 //line 73
            else                              //line 74                  
            {
                ub = false;
                Console.WriteLine(" Key is already exist.");
                Console.Read();
            }
            return parent;        //line 80
        }//end of Insert
        //***********************  //line 82
        public AVLNode  RightRotation(AVLNode parent, ref bool ub)  
        {
            AVLNode grandChild = new AVLNode();
            AVLNode child = new AVLNode();
            child = parent .Left ;
            if(child .Bf == 1)      //line 88
            {    //LL rotation
                Console.WriteLine("LL rotation for key " + parent.Key);
                parent.Left = child.Right;
                child .Right = parent ;
                parent.Bf = 0;
                parent = child ;
            }    //line 95
            else //LR rotation   //line 96
            {
                Console.WriteLine("LR rotation for key " + parent.Key);
                grandChild = child.Right;
                child .Right = grandChild .Left ;
                grandChild.Left = child;
                parent .Left = grandChild .Right ;
                switch (grandChild .Bf )
                {
                    case 1 :
                        parent.Bf = -1;
                        child .Bf = 0;
                        break;
                    case 0 :
                        parent.Bf = 0;
                        child.Bf = 0;
                        break ;
                    case -1:
                        parent .Bf = 0;
                        child .Bf = 1;
                        break;
                }//end of switch
                parent = grandChild ;
            } //end of else              //line 120
            parent .Bf = 0;
            ub = false; 
            Console.WriteLine("End of Rotation \n");
            return parent;
        }//end of method RightRotation     //line  125
        //*****************************
        public AVLNode  LeftRotation(AVLNode parent,  ref bool ub)//line 127 
        {
            Console.WriteLine("In left rotation");
            return parent;
        }                        //line 131
        //*****************
        public void InOrder(AVLNode theRoot)  //line 133
        {
            if (!(theRoot == null))
            {
                InOrder(theRoot.Left);
                theRoot.DisplayNode();
                InOrder(theRoot.Right);
            }//end of if
        }//end of InOrder                    //line 141
    }
}
